#include <RobotController.h>

#define STATE_STOP  0
#define STATE_FAST_FORWARD 1
#define STATE_FORWARD 2
#define STATE_FAST_BACKWARDS 3
#define STATE_BACKWARDS  4
#define STATE_RIGHT 5
#define STATE_LEFT 6

void vRunState(byte byCS) {
  switch (byCS) {
    case STATE_STOP: vMotion(0, 0);
      break;
    case STATE_FAST_FORWARD: vMotion(255, 255);
      break;
    case STATE_FORWARD: vMotion(127, 127);
      break;
    case STATE_FAST_BACKWARDS: vMotion(-255, -255);
      break;
    case STATE_BACKWARDS: vMotion(-127, -127);
      break;
    case STATE_RIGHT: vMotion(127, -127);
      break;
    case STATE_LEFT: vMotion(-127, 127);
      break;
  }
}

void setup() {
  Serial.begin(115200);
  RobotBegin();
  // while (!digitalRead(BUTTON_START));
  // Serial.println("Waiting for 5 seconds.");
  //delay(5000);
}
void loop() {
  static byte byCurrentState = STATE_STOP;
  int nUsDist = nUltrasonicCm();

  if (nUsDist > 50) {
    byCurrentState = STATE_FORWARD;
  } else if (nUsDist < 30) {
    byCurrentState = STATE_BACKWARDS;
  } else {
    byCurrentState = STATE_STOP;
  }
  vRunState(byCurrentState);
}
